var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { native } from '../decorators/native.js';
import { view } from '../decorators/view.js';
import { ViewBase } from '../view/view-base.js';
import { NativeComboBox, NativeComboBoxDelegate } from './native-combobox.js';
const ItemsProperty = {
    setNative: (view, _key, value) => {
        if (view.nativeView) {
            view.nativeView.setItems(value);
        }
    },
    shouldLayout: true,
};
let ComboBox = class ComboBox extends ViewBase {
    get isLeaf() {
        return true;
    }
    initNativeView() {
        this.nativeView = NativeComboBox.initWithOwner(new WeakRef(this));
        this.delegate = NativeComboBoxDelegate.initWithOwner(new WeakRef(this.nativeView));
        this.nativeView.delegate = this.delegate;
        this.nativeView.bezelStyle = NSTextFieldBezelStyle.Rounded;
        return this.nativeView;
    }
};
__decorate([
    native(ItemsProperty),
    __metadata("design:type", Array)
], ComboBox.prototype, "items", void 0);
ComboBox = __decorate([
    view({
        name: 'HTMLElement',
        tagName: 'combobox',
    })
], ComboBox);
export { ComboBox };
//# sourceMappingURL=combobox.js.map