var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var PopoverDelegate_1;
import { native } from "../decorators/native.js";
import { view } from "../decorators/view.js";
import { NativeView } from "../view/native-view.js";
import { ViewBase } from "../view/view-base.js";
let PopoverDelegate = PopoverDelegate_1 = class PopoverDelegate extends NSObject {
    static initWithOwner(_owner) {
        const popover = PopoverDelegate_1.new();
        popover.owner = _owner;
        return popover;
    }
};
PopoverDelegate.ObjCProtocols = [NSPopoverDelegate];
PopoverDelegate = PopoverDelegate_1 = __decorate([
    NativeClass
], PopoverDelegate);
let Popover = class Popover extends ViewBase {
    constructor() {
        super(...arguments);
        this.shouldAttachToParentNativeView = false;
        this.isRoot = true;
    }
    initNativeView() {
        this._popover = NSPopover.new();
        this.delegate = PopoverDelegate.initWithOwner(new WeakRef(this));
        this._popover.delegate = this.delegate;
        this._popover.contentViewController = NSViewController.new();
        this._popover.contentViewController.view = NativeView.new();
        this._popover.animates = true;
        this._popover.behavior = NSPopoverBehavior.Transient;
        this.nativeView = this._popover.contentViewController.view;
        return this.nativeView;
    }
    applyLayout(parentLayout) {
        super.applyLayout(parentLayout);
        if (this.nativeView && this._popover) {
            this._popover.contentSize = this.nativeView.frame.size;
        }
    }
    showFromEvent(event, edge) {
        const point = event.locationInWindow;
        if (this._popover) {
            this._popover.showRelativeToRectOfViewPreferredEdge({
                size: event.window.frame.size,
                origin: point,
            }, event.window.contentViewController.view || event.window.contentView, edge || NSRectEdge.MinYEdge);
        }
    }
    show(fromElement, edge) {
        if (this._popover) {
            const fromView = fromElement || this.parentNode;
            const bounds = fromView.nativeView.bounds;
            this._popover.showRelativeToRectOfViewPreferredEdge(bounds, fromView.nativeView, edge || NSRectEdge.MinYEdge);
        }
    }
    isShown() {
        return this._popover?.isShown;
    }
    hide() {
        this._popover?.performClose(null);
    }
};
__decorate([
    native({
        setNative: (view, key, value) => {
            if (view._popover) {
                view._popover.behavior = value;
            }
        },
    }),
    __metadata("design:type", Number)
], Popover.prototype, "behavior", void 0);
__decorate([
    native({
        setNative: (view, key, value) => {
            if (view._popover) {
                view._popover.animates = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], Popover.prototype, "animates", void 0);
Popover = __decorate([
    view({
        name: "HTMLPopoverElement",
        tagName: "popover",
    })
], Popover);
export { Popover };
//# sourceMappingURL=popover.js.map