import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import type { YogaNodeLayout } from '../../layout/index.js';
import type { ViewStyle } from '../../style/index.js';
import { View } from '../view/view.js';
export declare class ScrollChangeEvent extends Event {
    offset: {
        x: number;
        y: number;
    };
    constructor(offset: {
        x: number;
        y: number;
    }, eventDict?: EventInit);
}
export declare class NSScrollViewAutoResizable extends NSScrollView {
    _owner?: WeakRef<ScrollView>;
    initScrollEvents(owner: ScrollView): void;
    deinitScrollEvents(): void;
    boundsDidChange(_notification: NSNotification): void;
    static ObjCExposedMethods: {
        boundsDidChange: {
            returns: number;
            params: number[];
        };
    };
}
export declare class ScrollView extends View {
    nativeView?: NSScrollViewAutoResizable;
    documentView?: View;
    initNativeView(): NSScrollViewAutoResizable | undefined;
    private initDocumentView;
    disposeNativeView(): void;
    insertBefore<T extends Node>(node: T, child: Node | null): T;
    removeChild<T extends Node>(child: T): T;
    addNativeChild(child: any): void;
    removeNativeChild(_child: any): void;
    applyLayout(parentLayout?: YogaNodeLayout): void;
    documentViewStyle: ViewStyle;
    horizontal: boolean;
    private _disableDefaultDocumentView;
    disableDefaultDocumentView: boolean;
}
