import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { View } from '../view/view.js';
export declare class SliderChangeEvent extends Event {
    value?: number;
    constructor(value: number, eventDict?: EventInit);
}
export declare class NSSliderAutoResizable extends NSSlider {
    static ObjCExposedMethods: {
        sliderChanged: {
            returns: number;
            params: number[];
        };
    };
    static initWithOwner(owner: WeakRef<Slider>): NSSliderAutoResizable;
    _owner: WeakRef<Slider>;
    sliderChanged(_id: this): void;
}
export type SliderEvents = 'sliderChanged';
export declare class Slider extends View {
    get isLeaf(): boolean;
    nativeView?: NSSliderAutoResizable;
    initNativeView(): NSSliderAutoResizable | undefined;
    numberOfTickMarks: number;
    allowsTickMarkValuesOnly: boolean;
}
