import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { Text } from '../text/text.js';
export declare class TextChangeEvent extends Event {
    value: string;
    constructor(value: string, eventDict?: EventInit);
}
export declare class TextSubmitEvent extends Event {
    value: string;
    constructor(value: string, eventDict?: EventInit);
}
export declare class NativeTextFieldDelegate extends NSObject implements NSTextFieldDelegate {
    static ObjCProtocols: (typeof NSTextFieldDelegate)[];
    _owner: WeakRef<TextField>;
    static initWithOwner(owner: WeakRef<TextField>): NativeTextFieldDelegate;
    controlTextDidChange(obj: NSNotification): void;
    controlTextSubmit(): void;
    static ObjCExposedMethods: {
        controlTextSubmit: {
            returns: number;
            params: never[];
        };
    };
}
export declare class TextField extends Text {
    nativeView?: NSTextField;
    _delegate?: NSTextFieldDelegate;
    initNativeView(): NSTextField;
    prepareNativeView(nativeView: NSTextField): void;
    updateTextContent(): void;
    value: string;
    _defaultValueSet: boolean;
    defaultValue: string;
    placeholder: string | null;
    editable: boolean;
    multiline: boolean;
    focus(): void;
    blur(): void;
    clear(): void;
}
