var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var MainWindowController_1;
import '@nativescript/macos-node-api';
import { createEvent, Event } from '../../dom/dom-utils.js';
export class WindowResizeEvent extends Event {
    constructor() {
        super('resize');
    }
    initWindowEvent(type, bubbles, cancelable, width = 0, height = 0) {
        this.initEvent(type, bubbles, cancelable);
        this.width = width;
        this.height = height;
    }
}
let MainWindowController = MainWindowController_1 = class MainWindowController extends NSWindowController {
    static initWithOwner(owner) {
        const win = MainWindowController_1.new();
        win._owner = owner;
        return win;
    }
};
MainWindowController.ObjCProtocols = [NSToolbarDelegate];
MainWindowController = MainWindowController_1 = __decorate([
    NativeClass
], MainWindowController);
export { MainWindowController };
let NativeWindow = class NativeWindow extends NSWindow {
    windowDidResize(_notification) {
        const event = new WindowResizeEvent();
        event.initWindowEvent('resize', true, true, this.frame.size.width, this.frame.size.height);
        this.owner?.deref()?.dispatchEvent(event);
    }
    windowDidBecomeKey(_notification) {
        const event = createEvent('focus');
        this.owner?.deref()?.dispatchEvent(event);
    }
    windowWillClose(_notification) {
        const event = createEvent('close');
        const currentWindow = this.owner?.deref();
        currentWindow?.dispatchEvent(event);
        let window = null;
        let currentNode = currentWindow?.parentNode;
        while (window == null && currentNode !== null) {
            if (currentNode.nodeName === 'WINDOW') {
                window = currentNode.nativeView;
                break;
            }
            currentNode = currentNode.parentNode;
        }
        if (window) {
            window.makeKeyAndOrderFront(null);
        }
    }
};
NativeWindow.ObjCProtocols = [NSWindowDelegate];
NativeWindow = __decorate([
    NativeClass
], NativeWindow);
export { NativeWindow };
//# sourceMappingURL=native-window.js.map